#include <iostream>
#include <vector>
#include <iomanip>

// t = x2 / (x2-x1)
// y = (y1 * x2 + y2 * -x1) / (x2 - x1)


int main()
{
    int n;
    std::cin >> n;
    std::vector<int> x1(n);
    std::vector<int> y1(n);
    std::vector<int> x2(n);
    std::vector<int> y2(n);
    for(int i=0; i<n; i++)
    {
        std::cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
        if(x1[i] > x2[i])
        {
            std::swap(x1[i], x2[i]);
            std::swap(y1[i], y2[i]);
        }
    }
    
    int bestnum = 1;
    int bestdenom = 0;
    
    for(int i=0; i<n; i++)
    {
        if(x1[i] > 0 || x2[i] < 0)
            continue;
            
        int num = y1[i]*x2[i] + y2[i]*-x1[i];
        int denom = x2[i]-x1[i];
        if(num < 0)
            continue;

        if(num * bestdenom - bestnum * denom < 0)
        {
            bestnum = num;
            bestdenom = denom;
        }
    }
    if(bestdenom == 0)
        std::cout << "-1.0" << std::endl;
    else
        std::cout << std::setprecision(30) << double(bestnum)/double(bestdenom) << std::endl;
}
